var FLUX_JSON = "https://www.topchretien.com/api/passlemots/?format=json&limit=20";
var last_update = '';
var touchmoved;

var app = {
    // Application Constructor
    initialize: function() {
        this.bindEvents();
    },
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
        document.addEventListener('resume', this.onResume, false);
    },
    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicitly call 'app.receivedEvent(...);'
    onDeviceReady: function() {
    //storageRequest();
    //ajaxFlux();

        // app.receivedEvent('deviceready');
        load(function() {
            displayList(function(){
                schemeSetFB();
                schemeSetWhatsApp();
                schemeSetTwitter();
            });
            update(function(){
                displayList(function(){
                    schemeSetFB();
                    schemeSetWhatsApp();
                    schemeSetTwitter();
                });
                //NotifSchedule();
            });
        });

        var notificationOpenedCallback = function(jsonData) {
            console.log('notificationOpenedCallback: ' + JSON.stringify(jsonData));
        };

        // Push Notif. iOS Settings
        var iosSettings = {};
        iosSettings["kOSSettingsKeyAutoPrompt"] = false;
        iosSettings["kOSSettingsKeyInAppLaunchURL"] = false;

        // Initialize
        window.plugins.OneSignal
            .startInit("1931510c-f631-434a-a707-4d2fe3b17dbf", "770515097841")
            .iOSSettings(iosSettings)
            //.handleNotificationOpened(notificationOpenedCallback)
            .handleNotificationOpened(function(jsonData) {
            console.log("Notification opened:\n" + JSON.stringify(jsonData))
            })
            .inFocusDisplaying(window.plugins.OneSignal.OSInFocusDisplayOption.Notification)
            .endInit();
        //IOS Prompt for push notifications
        window.plugins.OneSignal.registerForPushNotifications();

        //LogLevel = print the logs info in the Xcode log or Android LogCat log.
        //window.plugins.OneSignal.setLogLevel({logLevel: 4, visualLevel: 0});

        window.plugins.OneSignal.getIds(function(ids) {
            console.log("userId = " + ids.userId + ", pushToken = " + ids.pushToken);
        });

        window.plugins.OneSignal.sendTags({key: "value", key2: "value2"});

    },

    onResume: function() {
        setTimeout(function() {
            console.log("App has been resumed")
                if (last_update > Date.now().set({hour:8,minute:0,second:0})) {
                    console.log("Refresh not needed, it has been updated this morning");
                    return;
                }
                update(function(){
                    displayList();
                });
        }, 0);
    }
};

app.initialize();

var listArticles = [];
/**
 * Charge depuis le disque la liste des articles. Appelle onLoad une fois le chargement effectué.
 */
function load(onLoad){
                            console.log("load");

    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fs) {
        fs.root.getFile("articles.json", { create: true, exclusive: false }, function (fileEntry) {
            fileEntry.file(function (file) {
                var reader = new FileReader();
                reader.onloadend = function() {
                    console.log("Reader.onloadend");
                    if (this.result != "") {
                        listArticles = JSON.parse(reader.result);
                        console.log(listArticles);
                    }
                    onLoad();
                };
                reader.readAsText(file);
            }, onErrorReadFile);
        }, onErrorCreateFile);
    }, onErrorLoadFs);
}

/** Enregistre sur le disque la liste des articles */
function save() {
    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fs) {
        fs.root.getFile("articles.json", { create: true, exclusive: false }, function (fileEntry) {
            var strJson = JSON.stringify(listArticles);
            var dataObj = new Blob([strJson], { type: 'text/plain' });
            fileEntry.createWriter(function (fileWriter) {
                fileWriter.onwriteend = function() {
                    if (fileWriter.length === 0) {
                        //fileWriter est vide ou à été vidé, donc on écrit le dataObj dans articles.json.
                        fileWriter.write(dataObj);
                    }
                };
                fileWriter.onerror = function (e) {
                    console.log("Failed file write: " + e.toString());
                };
                fileWriter.truncate(0);
            });
        }, onErrorCreateFile);

    }, onErrorLoadFs);
}

/** Mets à jour la liste des articles depuis le serveur. Appelle onComplete une fois la mise à jour effectuée */
function update(onComplete) {

    $.ajax({
        method: "GET",
        url: FLUX_JSON,
        dataType: "json",
        success: function (json) {
            console.log("update.process");

            var newListArticles = json.results;

            if (listArticles.length > 0 && listArticles[0].id == newListArticles[0].id) {
                console.log("Les articles sont à jour, pas besoin de refresh.");
                return;
            }

            listArticles = newListArticles;
            save();
            last_update = Date.now();
            if (onComplete) {
                onComplete();
                console.log("update.success");
                console.log("Articles mis à jour");
                console.log("Updated on " + last_update);
            }
        },
        error: function  (json, status, xhr) {
            console.log(status);
        }
    });
}

//Requête Ajax JS
function update(onComplete) {
    var request = new XMLHttpRequest();
    request.open('GET', FLUX_JSON, true);

    request.onload = function() {
        var json = JSON.parse(request.responseText);
      console.log("update.process");

                var newListArticles = json.results;

                if (listArticles.length > 0 && listArticles[0].id == newListArticles[0].id) {
                    console.log("Les articles sont à jour, pas besoin de refresh.");
                    return;
                }

                listArticles = newListArticles;
                save();
                last_update = Date.now();
                if (onComplete) {
                    onComplete();
                    console.log("update.success");
                    console.log("Articles mis à jour");
                    console.log("Updated on " + last_update);
                }
    };

request.onerror = function(json, status, request) {
  console.log(status);
};

request.send();

}


/** Mets à jour l'affichage de la liste des articles */
function displayList(onComplete) {
    console.log("Display list");

    console.log("Voici la liste des articles actuel : ");
    console.log(listArticles);

    var retourHtml = "";

    // On génère la liste des articles du flux RSS
    // On convertit la date anglaise, en français dans le fichier TabDate.
    $.each(listArticles, function(id, valeur){
        var enDate = new Date(valeur.pub_date);
        var frMonths = months[enDate.getMonth()];
        var frDay = days[enDate.getDay()];
        var date = enDate.getDate();
        var year = enDate.getFullYear();
        var frDate = frDay + " " + date + " " + frMonths + " " + year;
        var idPlm = valeur.id;
        // On stock aussi l'id de chaque article dans une variable.

        ////////////////////////////
        ///////VERSION JS///////////
        ////////////////////////////
    Array.prototype.forEach.call(listArticles, function(valeur, id) {
        var enDate = new Date(valeur.pub_date);
        var frMonths = months[enDate.getMonth()];
        var frDay = days[enDate.getDay()];
        var date = enDate.getDate();
        var year = enDate.getFullYear();
        var frDate = frDay + " " + date + " " + frMonths + " " + year;
        var idPlm = valeur.id;

    });

        // Ici on crée la section partage pour partager le PLM voulu avec son id et on met tout ça dans une variable Share.
        var Share = "PARTAGER" + ' <button id="btn-email'+ idPlm + '" class="btn-email">Email</button>' + '<button id="btn-fb'+ idPlm + '" class="btn-fb">Facebook</button>' + '<button id="btn-whatsapp'+ idPlm + '" class="btn-whatsapp">Whatsapp</button>'+ '<button id="btn-sms'+ idPlm + '" class="btn-sms">SMS</button>'+ '<button id="btn-twitter'+ idPlm + '" class="btn-twitter">Twitter</button>' + '<button id="btn-plus'+ idPlm + '" class="btn-plus">+</button>';

        //' <a title="Partage FB" href="https://www.facebook.com/dialog/share?app_id=145634995501895&display=page&href=http://www.topchretien.com/passlemot/pardonne-chaque-fois-que-tu-es-offense-jusqu-70-x-/">Partage FB</a>'
        // C'est l'ancien essai de partage FB, limité à un partage de lien. On ne peut partager directement du texte. Facebook policy.

        // On affiche le tout, pour chaque article.
        retourHtml +='<article id="plm-art'+ idPlm + '" class="plm-art">\
                <section id="plm-date" class="sec-date">'+ frDate + '</section>\
                <div class="plm-title">' + valeur.title.replace(/PassLeMot.fr/g, "") + '</div> <div class="plm-text-end">PassLeMot.fr</div>\
                <section id="plm-share' + idPlm + '" class="share-sec">' + Share + '<section>\
                </article>';

    });


    $("#passlemot-list").html(retourHtml);
    //$("#umcj-list-articles").listview("refresh");

/*    $('.plm-art').on("touchstart", function() {
        var idNum = this.id.replace('plm-art', '');
        //console.log("article cliqué");
        console.log(idNum);

        var idArt = this.id;
        //console.log(idArt);
        //showSharing(idArt);

        // Si le display de la section est à none, on affiche son élément,
        // en cachant ceux qui ont la classe "share-sec". Sinon, on cache tout
        if($('#plm-share' + idNum).css('display')=='none'){
            $('.share-sec').hide("fast");
            $('#plm-share' + idNum).show("fast");
        }else{
            $('.share-sec').hide("fast");
        }
        //TODO : Améliorer cette condition ? Il y a peut-être plus pratique.

        });*/

    $('.plm-art').on("touchend", function(e) {
        if(touchmoved != true){
            var idNum = this.id.replace('plm-art', '');
            //console.log("article cliqué");
            console.log(idNum);

            var idArt = this.id;
            //console.log(idArt);
            //showSharing(idArt);

            // Si le display de la section est à none, on affiche son élément,
            // en cachant ceux qui ont la classe "share-sec". Sinon, on cache tout
            if($('#plm-share' + idNum).css('display')=='none'){
                $('.share-sec').hide("fast");
                $('#plm-share' + idNum).show("fast");
            }else{
                $('.share-sec').hide("fast");
            }
        }
        //TODO : Améliorer cette condition ? Il y a peut-être plus pratique.

    }).on('touchmove', function(e){
        touchmoved = true;
    }).on('touchstart', function(e){
        touchmoved = false;
    });

    $('.btn-email').on("touchend", function(e) {
        if(touchmoved != true){
            idNumPlm = this.id.replace('btn-email', '');
            //console.log(idNum);
            //console.log(getPasslemotById(idNum).titre);
            ShareByEmail();
        }
    }).on('touchmove', function(e){
            touchmoved = true;
    }).on('touchstart', function(e){
            touchmoved = false;
    });

    $('.btn-fb').on("touchend", function(e) {
        if(touchmoved != true){
            idNumPlm = this.id.replace('btn-fb', '');
            //console.log(idNum);
            //console.log(getPasslemotById(idNum).titre);

            ShareByFB();
        }
    }).on('touchmove', function(e){
        touchmoved = true;
    }).on('touchstart', function(e){
        touchmoved = false;
    });

    $('.btn-whatsapp').on("touchend", function(e) {
        if(touchmoved != true){
            idNumPlm = this.id.replace('btn-whatsapp', '');
            //console.log(idNum);
            //console.log(getPasslemotById(idNum).titre);

            ShareByWhatsapp();
        }
    }).on('touchmove', function(e){
        touchmoved = true;
    }).on('touchstart', function(e){
        touchmoved = false;
    });

    $('.btn-sms').on("touchend", function(e) {
        if(touchmoved != true){
            idNumPlm = this.id.replace('btn-sms', '');
            //console.log(idNum);
            //console.log(getPasslemotById(idNum).titre);

            ShareBySms();
        }
    }).on('touchmove', function(e){
        touchmoved = true;
    }).on('touchstart', function(e){
        touchmoved = false;
    });

     $('.btn-twitter').on("touchend", function(e) {
        if(touchmoved != true){
            idNumPlm = this.id.replace('btn-twitter', '');
            //console.log(idNum);
            //console.log(getPasslemotById(idNum).titre);

            ShareByTwitter();
        }
    }).on('touchmove', function(e){
        touchmoved = true;
    }).on('touchstart', function(e){
        touchmoved = false;
    });

     $('.btn-plus').on("touchend", function(e) {
        if(touchmoved != true){
            idNumPlm = this.id.replace('btn-plus', '');
            //console.log(idNum);
            //console.log(getPasslemotById(idNum).titre);

            ShareWithOther();
        }
    }).on('touchmove', function(e){
        touchmoved = true;
    }).on('touchstart', function(e){
        touchmoved = false;
    });

     if (onComplete) {
            onComplete();
            console.log("Affichage de la liste effectuée.");
        }
}

function onErrorLoadFs() {
        console.log("onErrorLoadFs occurs!!");
    }

function onErrorCreateFile() {
        console.log("onErrorCreateFile occurs!!");
    }

function onErrorReadFile() {
    console.log("onErrorReadFile occurs!!");
}

function showSharing(idArt) {
    $("#plm-share").show();
    console.log("showSharing OK");
}

// callbacks
function onSuccess(msg) {
    console.log('SocialSharing success: ' + msg);
}

function onError(msg) {
    alert("Partage impossible, application non installée.");
    console.log('SocialSharing error: ' + msg);
}

function getPasslemotById(id) {
    for(var i = 0 ; i < listArticles.length ; i++) {
        if (listArticles[i].id == id) {
            return listArticles[i];
        }
    }
    return null;
};

function TimeScheduledAt8() {
    //Ici on va vérifier si l'heure actuelle est au delà de 8h du matin, sinon on programme pour le lendemain.
    //tomorrow_at_8_am = Date.today().next().day().add(8).hours();
    tomorrow_at_8_am = Date.now().next().day().set({hour:8,minute:0,second:0});
    at_8_am = Date.now().set({hour:8,minute:0,second:0});
    var now = Date.now();

    if (now > at_8_am) {
        console.log("tomorrow_at_8_am"),
        tomorrow_at_8_am;
    }
    else{
        console.log("at_8_am"),
        at_8_am;
    }
}

function NotifSchedule() {
    console.log("On programme les notifications")
    // On lance la fonction ScheduleLog pour savoir si les notifs ont été planifiées
    ScheduleLog();

    // On va chercher le dernier titre du dernier article dans le JSON
    var lastPlm = listArticles[0].title;

    ////////DATE FACON NATIVE :
    //var now = new Date().getTime(),
    _15_sec_from_now = new Date(now + 15 * 1000);
    //monday = new Date("Mon, 27 Jun 2016 10:00:00 +0200");
    //tomorrow = new Date(now + 86400000);
    //morning = new Date("Thu, 07 Jul 2016 08:00:00 +0200");
    //tomorrow_at_8_am = new Date("Fri, 08 Jul 2016 08:00:00 +0200");
    //test = new Date("Thu, 07 Jul 2016 17:50:00 +0200");

    ///////TEST AVEC LA LIB DATE.JS :
    var now = Date.now(),
    _25_sec_from_now = Date.now().add(25).seconds();

    ///////HOURLY NOTIF : Variable
    hourly = Date.now().next().hour().set({minute:0,second:0});
    //test = Date.today();

    ///////DAILY NOTIF : Variables
    tomorrow_at_8_am = Date.now().next().day().set({hour:8,minute:0,second:0});
    //Pareil que : tomorrow_at_8_am = Date.today().next().day().add(8).hours();
    at_8_am = Date.now().set({hour:8,minute:0,second:0});

    //Ici on va vérifier si l'heure actuelle est au delà de 8h du matin, sinon on programme pour le lendemain.
    // Et on met l'heure dans la variable test8am
    // A noter qu'avec le plugin notif local, je ne peux utiliser de fonctions dans l'option "at",
    // sinon la notif daily s'enclenche directe peu importe l'heure, et ne fonctionne pas daily.
    // J'avais testé en créant une fonction TimeScheduledAt8().
    var test8am;

    if (now > at_8_am) {
        console.log("tomorrow_at_8_am"),
        test8am = tomorrow_at_8_am;
    }
    else{
        console.log("at_8_am"),
        test8am = at_8_am;
    };


    ////////SCHEDULING DES NOTIFS
        //var sound = device.platform == 'Android' ? 'file://sound.mp3' : 'file://beep.caf';
    cordova.plugins.notification.local.schedule([{
        id: 1,
        title: 'PassLeMot d\'aujourd\'hui',
        text: lastPlm,
        at: _15_sec_from_now,
        led: "FF0000",
        sound: null,
        badge: 12
    },
        {
        id: 2,
        title: 'PassLeMot d\'aujourd\'hui',
        text: 'TestDailyNotif',
        at: test8am,
        every: "day",
        led: "FF0000",
        sound: null,
        badge: 13
    },
        {
        id: 3,
        title: 'PassLeMot d\'aujourd\'hui',
        text: 'TestHourlyNotif',
        at: hourly,
        every: "hour",
        led: "FF0000",
        sound: null,
        badge: 14
    },
        {
        id: 4,
        title: 'PassLeMot d\'aujourd\'hui',
        text: '25 sec',
        at: _25_sec_from_now,
        led: "FF0000",
        sound: null,
        badge: 12
    }]);

    NotifTrigger();
    NotifQuery();
    Notiftouchstarted();
}

function ScheduleLog() {
    cordova.plugins.notification.local.on("schedule", function(notification) {
        console.log("scheduled notification: " + notification.id);
    });
}
function NotifTrigger() {
     cordova.plugins.notification.local.on("trigger", function(notification) {
        console.log("notification: " + notification.id + " triggered");
    });
}
function Notiftouchstarted(){
    cordova.plugins.notification.local.on("touchstart", function(notification) {
        console.log("notification: " + notification.id + " touchstarted");
    });
}
function NotifQuery() {
    cordova.plugins.notification.local.getTriggered(function (notifications) {
        console.log(notifications.length + " notifications planifiées");
    });
}

function checkSimulator() {
    if (window.navigator.simulator === true) {
        alert('This plugin is not available in the simulator.');
        return true;
    } else if (window.plugins === undefined || window.plugins.socialsharing === undefined) {
        alert('Plugin not found. Maybe you are running in AppBuilder Companion app which currently does not support this plugin.');
        return true;
    } else {
        return false;
    }
}

function schemeSetFB() {
    var schemeFB;

    if(device.platform === 'iOS') {
        schemeFB = 'fb://';
    }
    else if(device.platform === 'Android') {
        schemeFB = 'com.facebook.katana';
    }

    appAvailability.check(
        schemeFB,       // URI Scheme or Package Name
        function() {  // Success callback
            console.log(schemeFB + ' is available :)');
        },
        function() {  // Error callback
            console.log(schemeFB + ' is not available :(');
            if ($('.btn-fb').hide()) {
                console.log("Bouton FB caché");
            }
        }
    );
}

function schemeSetWhatsApp() {
    var schemeWhatsApp;

    if(device.platform === 'iOS') {
        schemeWhatsApp = 'whatsapp://';
    }
    else if(device.platform === 'Android') {
        schemeWhatsApp = 'com.whatsapp';
    }

    appAvailability.check(
        schemeWhatsApp,       // URI Scheme or Package Name
        function() {  // Success callback
            console.log(schemeWhatsApp + ' is available :)');
        },
        function() {  // Error callback
            console.log(schemeWhatsApp + ' is not available :(');
            if ($('.btn-whatsapp').hide()){
                console.log("Bouton Whatsapp caché");
            }
        }
    );
}

function schemeSetTwitter() {
    var schemeTwitter;

    if(device.platform === 'iOS') {
        schemeTwitter = 'twitter://';
    }
    else if(device.platform === 'Android') {
        schemeTwitter = 'com.twitter.android';
    }

    appAvailability.check(
        schemeTwitter,       // URI Scheme or Package Name
        function() {  // Success callback
            console.log(schemeTwitter + ' is available :)');
        },
        function() {  // Error callback
            console.log(schemeTwitter + ' is not available :(');
           if ($('.btn-twitter').hide()){
            console.log("Bouton Twitter caché");
           }
        }
    );
}

function ShareWithOther() {

    var options = {
      message: getPasslemotById(idNumPlm).title, //ex: 'share this', not supported on some apps (Facebook, Instagram)
      subject: 'PassLeMot du jour', // fi. for email
      files: ['', ''], // an array of filenames either locally or remotely
      url: '', //'https://www.website.com/foo/#bar?a=b'
      chooserTitle: 'Choisissez une application.' // Android only, you can override the default share sheet title
    }

    var onSuccessOther = function(result) {
      console.log("Share completed? " + result.completed); // On Android apps mostly return false even while it's true
      console.log("Shared to app: " + result.app); // On Android result.app is currently empty. On iOS it's empty when sharing is cancelled (result.completed=false)
    }

    var onErrorOther = function(msg) {
      console.log("Sharing failed with message: " + msg);
    }

    window.plugins.socialsharing.shareWithOptions(options, onSuccessOther, onErrorOther);
}


function ShareByEmail() {
    // check for a configured email client
    //window.plugins.socialsharing.canShareViaEmail([success], [error]);
    console.log(idNumPlm);

        if (!this.checkSimulator()) {
        window.plugins.socialsharing.shareViaEmail(
          getPasslemotById(idNumPlm).title, // C'est le corps du message de l'e-mail
          // can contain HTML tags, but support on Android is rather limited:  http://stackoverflow.com/questions/15136480/how-to-send-html-content-with-image-through-android-default-email-client
          'PassLeMot du jour', // Sujet de l'email
          null, // Destinataire
          null, // CC
          //['to@person1.com', 'to@person2.com'], // TO: must be null or an array
          //['cc@person1.com'], // CC: must be null or an array
          null, // BCC: must be null or an array
          null, // FILES: can be null, a string, or an array
          onSuccess, // called when sharing worked, but also when the user cancelled sharing via email. On iOS, the callbacks' boolean result parameter is true when sharing worked, false if cancelled. On Android, this parameter is always true so it can't be used). See section "Notes about the successCallback" below.
          onError // called when sh*t hits the fan
        );
    }
}

function ShareByFB() {

    // For the files param you can pass null, a single string or an array.
    window.plugins.socialsharing.shareViaFacebookWithPasteMessageHint(getPasslemotById(idNumPlm).url, null, null, null, this.onSuccess, this.onError);
}

function ShareByTwitter() {

    window.plugins.socialsharing.shareViaTwitter(getPasslemotById(idNumPlm).title, null, null, this.onSuccess, this.onError);
}

function ShareByWhatsapp() {

    window.plugins.socialsharing.shareViaWhatsApp (getPasslemotById(idNumPlm).title, null, null, this.onSuccess, this.onError);

}

function ShareBySms() {

    window.plugins.socialsharing.shareViaSMS (getPasslemotById(idNumPlm).title, null, this.onSuccess, this.onError);
}
