var FLUX_JSON = "https://www.topchretien.com/api/passlemots/?format=json&limit=20";
var last_update = '';
/*var touchmoved;*/
var listArticles = [];

var app = {
    // Page init event
  openMenu: function() {
    var menu = document.getElementById('menu');
    menu.open();
  },

  loadMenu: function(page) {
    var content = document.getElementById('navigator');
    var menu = document.getElementById('menu');
    var about = document.getElementById('about-page');
    if (page === "homePage.html") {
      document.getElementById('content').load(page)
          .then(menu.close.bind(menu));
    }else{
    content.pushPage(page)
      .then(menu.close.bind(menu));
    }
  },

  bindEvents: function() {
      document.addEventListener('resume', this.onResume, false);
  },

  oneSignalInit: function() {
    console.log("oneSignalInit");

    var notificationOpenedCallback = function(jsonData) {
        console.log('notificationOpenedCallback: ' + JSON.stringify(jsonData));
    };

  // Push Notif. iOS Settings
    var iosSettings = {};
        iosSettings["kOSSettingsKeyAutoPrompt"] = false;
        iosSettings["kOSSettingsKeyInAppLaunchURL"] = false;

    // Initialize
    window.plugins.OneSignal
        .startInit("1931510c-f631-434a-a707-4d2fe3b17dbf", "770515097841")
        .iOSSettings(iosSettings)
        //.handleNotificationOpened(notificationOpenedCallback)
        .handleNotificationOpened(function(jsonData) {
        console.log("Notification opened:\n" + JSON.stringify(jsonData))
        })
        .inFocusDisplaying(window.plugins.OneSignal.OSInFocusDisplayOption.Notification)
        .endInit();
    //IOS Prompt for push notifications
    window.plugins.OneSignal.registerForPushNotifications();

    //LogLevel = print the logs info in the Xcode log or Android LogCat log.
    //window.plugins.OneSignal.setLogLevel({logLevel: 4, visualLevel: 0});

    window.plugins.OneSignal.getIds(function(ids) {
        console.log("userId = " + ids.userId + ", pushToken = " + ids.pushToken);
    });

    window.plugins.OneSignal.sendTags({key: "value", key2: "value2"});

  },

  onResume: function() {
      setTimeout(function() {
          console.log("App has been resumed")
              if (last_update > Date.now().set({hour:8,minute:0,second:0})) {
                  console.log("Refresh not needed, it has been updated this morning");
                  return;
              }
              update(function(){
                  displayList();
              });
      }, 0);
  }
};


document.addEventListener('init', function(event) {

  page = event.target;

  console.log("page", page.id);

  if (page.id === 'first-page') {
      if (listArticles.length === 0) {
        console.log("App launch, fetching content");
        update(function() {
          displayList();
          console.log("Content fetched");



        });
      } else if (listArticles[0].id === newListArticles[0].id) {
        console.log("listArticles[0].id === newListArticles[0].id, then displaylist");
        displayList();
      } else {
        console.log("content might be old, load from local storage, then update");
        load(function() {
          displayList();

          update(function() {
              displayList();
          });
        });
      }
  }

});

var matches;

(function(doc) {
   matches = 
      doc.matchesSelector ||
      doc.webkitMatchesSelector ||
      doc.mozMatchesSelector ||
      doc.oMatchesSelector ||
      doc.msMatchesSelector;
})(document.documentElement);

document.addEventListener('click', function(e) {
    e = e || window.event;
    element = e.target || e.srcElement;
    console.log(element);

if (element.tagName == 'A' || element.parentElement.tagName == 'A') {
      console.log(element);
      externalUrlHandler();
      e.preventDefault();
      return false;

   } else if ( matches.call(element, '.share-button') ) {
      console.log("share button pushed");
      idNumPlm = element.id.replace('share-button', '');
      console.log(idNumPlm);
      Share();
   }
}, false);


ons.ready(function(){
      console.log("ons.ready");
      app.oneSignalInit();
      app.bindEvents();
});

/** Mets à jour l'affichage de la liste des articles */
function displayList(onComplete) {
  console.log("Process Display list");

  console.log("Here is the content list : ");
  console.log(listArticles);
  var returnHtml = "";

  for(var i=0; i < listArticles.length; i++)
  {

      // On génère la liste des articles du flux RSS
      // On convertit la date anglaise, en français dans le fichier TabDate.
      var enDate = new Date(listArticles[i].pub_date);
      var frMonths = months[enDate.getMonth()];
      var frDay = days[enDate.getDay()];
      var date = enDate.getDate();
      var year = enDate.getFullYear();
      var frDate = frDay + " " + date + " " + frMonths + " " + year;
      var idPlm = listArticles[i].id;
      var titleModified = listArticles[i].title.replace(/PassLeMot.fr/g, "");

      returnHtml +=
        '<ons-list-item modifier="material nodivider" class="plm-list-item"><article id="plm-art'+ idPlm + '" class="plm-art">\
                <section id="plm-date" class="sec-date">'+ frDate + '</section>\
                <div class="plm-title">' + titleModified.replace(/(.*?)\).(.*)/,"<strong>$1). </strong>$2") + '<section id="plm-button" class="plm-button">\
                <ons-button modifier="material" disable-auto-styling id="share-button' + idPlm + '" class="share-button"> Je Passe Le Mot </ons-button>' + '</section>\
                </article></ons-list-item>';

  }

  document.getElementById('article-list').innerHTML = returnHtml;

  if (onComplete) {
      onComplete();
      console.log("Display list completed.");
  }

}


function onErrorLoadFs() {
        console.log("onErrorLoadFs occurs!!");
    }

function onErrorCreateFile() {
        console.log("onErrorCreateFile occurs!!");
    }

function onErrorReadFile() {
    console.log("onErrorReadFile occurs!!");
}

/**
 * Charge depuis le disque la liste des articles. Appelle onLoad une fois le chargement effectué.
 */
function load(onLoad){
    console.log("load.process");

    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fs) {
        fs.root.getFile("articles.json", { create: true, exclusive: false }, function (fileEntry) {
            fileEntry.file(function (file) {
                var reader = new FileReader();
                reader.onloadend = function() {
                    console.log("Reader.onloadend");
                    if (this.result != "") {
                      console.log("this.result");
                        listArticles = JSON.parse(reader.result);
                        console.log(listArticles);
                    }
                    console.log("load.success");
                    onLoad();
                };
                reader.readAsText(file);
            }, onErrorReadFile);
        }, onErrorCreateFile);
    }, onErrorLoadFs);
}

/** Enregistre sur le disque la liste des articles */
function save() {
    console.log("save.process");

    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fs) {
        fs.root.getFile("articles.json", { create: true, exclusive: false }, function (fileEntry) {
            var strJson = JSON.stringify(listArticles);
            var dataObj = new Blob([strJson], { type: 'text/plain' });
            fileEntry.createWriter(function (fileWriter) {
                fileWriter.onwriteend = function() {
                    if (fileWriter.length === 0) {
                        //fileWriter est vide ou à été vidé, donc on écrit le dataObj dans articles.json.
                        fileWriter.write(dataObj);
                        console.log("save.success");
                        lastSaveDate = Date.now();
                        console.log("Save date: " + lastSaveDate);
                    }
                };
                fileWriter.onerror = function (e) {
                    console.log("Failed file write: " + e.toString());
                };
                fileWriter.truncate(0);
            });
        }, onErrorCreateFile);

    }, onErrorLoadFs);
}

/** Mets à jour la liste des articles depuis le serveur. Appelle onComplete une fois la mise à jour effectuée */
function update(onComplete) {

    var request = new XMLHttpRequest();
    request.open('GET', FLUX_JSON, true);

    console.log("update.process");

    request.onreadystatechange = function(){

      if(request.readyState == 4) {
        console.log("Parsing JSON");
        json = JSON.parse(request.responseText);
        newListArticles = json.results;
        console.log("newListArticles = ");
        console.log(newListArticles);

        if (listArticles.length > 0 && listArticles[0].id === newListArticles[0].id) {
            console.log("Les articles sont à jour, pas besoin de refresh.");
            return;
        }

        listArticles = newListArticles;

        save();
        last_update = Date.now();
        if (onComplete) {
            onComplete();
            console.log("update.success");
            console.log("Articles mis à jour");
            console.log("Updated on " + last_update);
        }

      }

    }

    request.onerror = function(json, status, request) {
    console.log(status);

    };

    request.send();
}

function getPasslemotById(id) {
    for(var i = 0 ; i < listArticles.length ; i++) {
        if (listArticles[i].id == id) {
            return listArticles[i];
        }
    }
    return null;
}

function externalUrlHandler() {
    var url = element.href || element.parentElement.href;
    if (ons.platform.isAndroid()) {
      console.log("platform is Android");
      navigator.app.loadUrl(url, { openExternal: true });
    } else {
      console.log("platform is Chrome or IOS or else");
      window.open(url, "_system", 'location=yes');
    }
}

function Share() {
    var message = getPasslemotById(idNumPlm).title
    var subject = 'PassLeMot'
    var link = null
    var options = {
      message: getPasslemotById(idNumPlm).title, //ex: 'share this', not supported on some apps (Facebook, Instagram)
      subject: 'PassLeMot du jour', // fi. for email
      files: ['', ''], // an array of filenames either locally or remotely
      url: getPasslemotById(idNumPlm).url, //'https://www.website.com/foo/#bar?a=b'
      chooserTitle: 'Choisissez une application.' // Android only, you can override the default share sheet title
    }

    var onSuccessOther = function(msg) {
      console.log("Share completed? " + msg); // On Android apps mostly return false even while it's true
      console.log("Shared to app: " + msg); // On Android result.app is currently empty. On iOS it's empty when sharing is cancelled (result.completed=false)
    }

    var onErrorOther = function(msg) {
      console.log("Sharing failed with message: " + msg);
    }

    window.plugins.socialsharing.share(message, subject, null, link, onSuccessOther, onErrorOther);
}

//TODO :
// Ensuite continuer à transformer les code JQUERY en JS.